<template>
  <div>
    <Modal v-model="showModal" :mask-closable="false" :zIndex = -1 width="1250">
      <p slot="header">{{modalTitle}}</p>
      <div>
        <Form id="edit-form" ref="formObj" :model="formObj" :rules="ruleValidate" :label-width="90" inline>

          <Form-item  label="委托单位" prop="client" class="width-48">
            <AutoComplete :value="formObj.client" :down-data="customerData" @on-result-change="_cusNameChange"
                          name="client" placeholder="请输入或选择委托单位"
            ></AutoComplete>
          </Form-item>
          <Form-item label="联系人" prop="person" class="width-48">
            <Input v-model="formObj.person" name="person" placeholder="请输入联系人"/>
          </Form-item>
          <Form-item label="联系电话" prop="tel" class="width-48">
            <Input v-model="formObj.tel" name="tel" placeholder="请输入联系电话"/>
          </Form-item>
          <Form-item label="传真" prop="fax" class="width-48">
            <Input v-model="formObj.fax" name="fax" placeholder="请输入传真"/>
          </Form-item>
          <Form-item label="省、市、区" prop="testedCityData" class="width-48">
            <CityNameCascader :value="testedCityData.join(',')" @on-result-change="_cascaderResult" name="tested">
            </CityNameCascader>
          </Form-item>

          <Form-item label="街道" prop="street" class="width-48">
            <Input v-model="formObj.street" name="street" placeholder="请输入街道"/>
          </Form-item>
          <Form-item label="要求完成时间：" prop="odate" class="width-48">
            <Date-picker v-model="formObj.odate" @on-change="_ctimeChange" type="date" split-panels style="width:100%;"
                         placeholder="请选择要求完成时间"></Date-picker>
          </Form-item>
          <Form-item label="折扣：" prop="discount" class="width-48">
            <Input v-model="formObj.discount" name="discount" placeholder="折扣"/>
          </Form-item>

          <Form-item label="检定/校准执行规程/规范：" prop="requirements" style="width: 99.8%">
            <Input v-model="formObj.requirements" :rows="3" name="requirements" type="textarea"
                   placeholder="请输入检定/校准执行规程/规范"/>
          </Form-item>
          <Form-item label="备注：" prop="remark" style="width: 99.8%">
            <Input v-model="formObj.remark" :rows="3" name="remark" type="textarea"
                   placeholder="请输入备注"/>
          </Form-item>
        </Form>

        <!--操作-->
        <Col span="24">

          <btn-list :msg="btn" :open="searchOpen" :show-search-btn="true" @on-result-change="_btnClick"
                    class="contHide"></btn-list>
        </Col>
        <Col span="24">
          <PTVXETable
            ref="pageTable"
            :form-id="formId"
            :table-height="500"
            :get-page="getPage"
            :icon-msg="iconMsg"
            @on-result-change="_tableResultChange">
            <vxe-table-column
              v-for="item in pageColumns"
              :key="item.key"
              :field="item.key"
              :title="item.title"
              :width="item.width"
              :min-width="200"
              :fixed="item.fixed?item.fixed:undefined"
              sortable
            >
              <template slot-scope="scope">
                <div v-if="item.key==='name'" @click.stop="_handleRow(scope)">
                  <el-input v-model="scope.row.name" blur style="width: 150px;"  placeholder="请输入或选择样品名称"
                  ></el-input>
                  <a @on-result-change="_judgeBasisChange" @click="_selectjudgeBasis(scope.$rowIndex)" style="font-size: 18px;" class="">+</a>
                </div>
                <div v-if="item.key==='spec'" @click.stop="_handleRow(scope)">
                  <el-input v-model="scope.row.spec" blur placeholder="请输入或选择型号规格"
                  ></el-input>
                </div>
                <div v-if="item.key==='factoryNumber'" @click.stop="_handleRow(scope)">
                  <el-input v-model="scope.row.factoryNumber" blur placeholder="请输入或选择出厂编号"
                  ></el-input>
                </div>

                <div v-if="item.key==='technicalParameter'" @click.stop="_handleRow(scope)">
                  <el-input v-model="scope.row.technicalParameter" blur placeholder="请输入技术参数"
                  ></el-input>
                </div>


                <div v-if="item.key==='manufacturer'" @click.stop="_handleRow(scope)">
                  <el-input v-model="scope.row.manufacturer" blur placeholder="请输入生产厂家"
                  ></el-input>
                </div>

                <div v-if="item.key==='type'" @click.stop="_handleRow(scope)">
                  <Select v-model="scope.row.type">
                    <Option v-for="(item,index) in options" :key="item.name" :value="index">
                      {{ item.name }}
                    </Option>
                  </Select>
                </div>
                <div v-if="item.key==='quantity'" @click.stop="_handleRow(scope)" >
                  <el-input
                    v-model="scope.row.quantity"
                    @input="_quantityChange(scope.$rowIndex)"
                    @keydown.native="channelInputLimit"
                    type="number"
                    placeholder="请输入或选择数量"
                  />
                </div>
                <div v-if="item.key==='price'" @click.stop="_handleRow(scope)" >
                  <el-input
                    v-model="scope.row.price"
                    @input="_quantityChange(scope.$rowIndex)"
                    @keydown.native="channelInputLimit"
                    type="number"
                  />
                </div>
                <div v-if="item.key==='lastTime'" @click.stop="_handleRow(scope)">
                  <Date-picker v-model="scope.row.lastTime" type="date" split-panels style="width:100%;"
                               placeholder="请选择上次检定时间"></Date-picker>
                </div>
                <div v-if="item.key==='unit'" @click.stop="_handleRow(scope)">
                  <el-input v-model="scope.row.unit" blur placeholder="请输入收费单位"
                  ></el-input>
                </div>

                <div v-if="item.key==='remark'" @click.stop="_handleRow(scope)">
                  <el-input v-model="scope.row.remark" blur placeholder="请输入备注"
                  ></el-input>
                </div>

                <div v-else-if="item.date">
                  {{ scope.row[item.key]?$dateformat(scope.row[item.key],'yyyy-mm-dd'):'' }}
                </div>
                <div v-else @click.stop="_handleRow(scope)">
                  <span> {{ scope.row[item.key] }}</span>
                </div>
              </template>
            </vxe-table-column>
          </PTVXETable>
        </Col>
      </div>
      <div slot="footer">
        <modal-footer ref="footerModal" :footer="footerList" @on-result-change="_footerResult"></modal-footer>
      </div>
    </Modal>
    <EditModal ref="EditModal" @on-result-change="_backData" is-change />
    <importModal ref="importModal" @on-result-change="_inputBack"   aptitude-item></importModal>
  </div>
</template>
<script>
/**
 * 添加编辑分包商
 */
import {
  lmsBaseDict,
  meterEntrust,
  meterContract,
  meterSampleQuote
} from '../../../api'
import CityNameCascader from '../../../components/base/CityNameCascader'
import AutoComplete from '../../../components/base/AutoCompletes'
import importModal from '../../../components/import/DownloadTemplateImport'
import EditModal from './EditModal'

export default {
  components: { CityNameCascader, EditModal, AutoComplete, importModal },
  data() {
    const validateRemark = (rule, value, callback) => {
      if (this.testedCityData.length === 0) {
        callback(new Error('内容不能为空'))
      } else {
        callback()
      }
    }
    const validateClient = (rule, value, callback) => {
      if (this.formObj.client === '') {
        callback(new Error('内容不能为空'))
      } else {
        callback()
      }
    }
    return {
      formId: 'meterSendTestEditFormId',
      getPage: {
        records: []
      },
      searchOpen: true,
      customerData: [],
      cityData: [],
      testedCityData: [],
      judgeType: [{ value: 1, name: '是' }, { value: 0, name: '否' }],
      iconMsg: [
        // { type: 'md-create', id: '', name: '编辑' },
        {
          type: 'md-trash',
          id: 'meter-quote-register-edit-remove-o',
          name: '删除'
        }
      ],
      pageColumns: [
        { title: '名称', key: 'name', width: 200 },
        { title: '型号', key: 'spec' },
        { title: '数量', key: 'quantity' },
        { title: '技术参数', key: 'technicalParameter' },
        { title: '生产厂家', key: 'manufacturer' },
        { title: '出厂编号', key: 'factoryNumber' },
        { title: '上次检定校准日期', key: 'lastTime', date: true },
        { title: '收费单位', key: 'unit' },
        { title: '单价/元', key: 'price' },
        { title: '总价/元', key: 'totalPrice' },
        { title: '备注', key: 'remark' }

        // {title: '限制范围或说明', key: 'limitDescription'},
      ],
      options: [
        {
          name: '检定'
        },
        {
          name: '校准'
        },
        {
          name: '外观检查'
        }
      ],
      btn: [
        {
          type: 'success',
          id: 'meter-quote-register-edit-add',
          name: '添加'
        },
        {
          type: 'success',
          id: 'quote-register-meter-quote-register-edit-import',
          name: '导入'
        }
      ],
      id: '',
      modalTitle: '',
      subcontractorId: '',
      formObj: {
        client: '',
        linkman: '',
        tel: '',
        email: '',
        address: '',
        remark: '',
        province: '',
        city: '',
        county: '',
        requirements: '',
        discount: '',
        street: '',
        edate: '',
        odate: '',
        person: '',
        fax: '',
        testedTemp: {
          testedProvince: '',
          testedCity: '',
          testedCounty: '',
          testedStreet: ''
        }
      },

      ruleValidate: {
        client: [
          {
            required: true,
            message: '委托单位不能为空',
            validator: validateClient,
            trigger: 'blur'
          }
        ],
        person: [
          { required: true, message: '联系人不能为空', trigger: 'blur' }
        ],
        tel: [{ required: true, message: '联系电话不能为空', trigger: 'blur' }],
        testedCityData: [
          {
            required: true,
            message: '省市区不能为空',
            validator: validateRemark,
            trigger: 'blur'
          }
        ]
      },

      clearingWayList: ['款到后测试', '先测试后付款', '其他情况（）'],
      clearingWayListTemp: ['款到后测试', '先测试后付款', '其他情况（）'],
      showModal: false,
      footerList: [
        { id: '', name: '取消', type: '' },
        { id: '', name: '保存', type: 'primary' }
      ],
      aptitudeData: []
    }
  },
  // created() {
  //   this.$set(
  //     this.formObj,
  //     'tested',
  //     JSON.parse(JSON.stringify(this.testedTemp))
  //   )
  // },
  methods: {
    _cusNameChange(msg, data) {
      // this.financeObj = {} // 清空维护发票信息的数据
      if (this.$string(this.id).isEmpty()) {
        // 添加的时候选择单位
        switch (msg) {
          case 'select':
            this._customerMatch(data)
            break
          case 'query':
            this._cusNameQuery(data)
            break
        }
      } else if (this.customerData.indexOf(data) !== -1) {
        this._getQueryList(data)
        // 编辑的时候选择单位(互不影响)
        // this.cusName = data
        // this.formObj.customer.cname = data
      } else {
      }
    },
    _customerMatch(data) {
      this._getQueryList(data)
    },
    _cusNameQuery(query) {
      this.formObj.client = query
    },
    _ctimeChange(data) {
      console.log('时间', data)
      this.formObj.odate = data
      // this.formObj.ctimeBegin = data[0]
      // this.formObj.ctimeEnd = data[1]
    },
    _judgeBasisChange(msg, data) {
      switch (msg) {
        case 'select':
          this.formObj.stdId = data.id
          this.formObj.code = data.stdNum
          this.formObj.name = data.name
          this.$refs.formObj.validateField('code')
          break
        case 'query':
          this.formObj.stdId = ''
          this.formObj.code = data.stdNum
          this.formObj.name = ''
          this._getJudgeBasisList(data.stdNum)
          break
        case 'focus':
          this._getJudgeBasisList()
          break
        case 'blur':
          if (this.formObj.stdId === '') {
            this.formObj.code = ''
            this._getJudgeBasisList()
          }
          this.$refs.formObj.validateField('code')
      }
    },
    _selectjudgeBasis(index) {
      console.log(index)
      this.index = index
      this.$refs.EditModal._open()
    },

    _quantityChange(index) {
      this.$forceUpdate()
      this.index = index
      if (
        undefined !== this.getPage.records[this.index].price &&
        undefined !== this.getPage.records[this.index].quantity
      ) {
        this.getPage.records[this.index].totalPrice =
          this.getPage.records[this.index].quantity *
          this.getPage.records[this.index].price
      }
    },

    _backData(data) {
      console.log(typeof this.index)
      this.getPage.records[this.index].name = data.name
      this.getPage.records[this.index].aptitudeId = data.id
      this.getPage.records[this.index].price = data.price
      this._priceCal()
    },

    _priceCal() {
      if (
        undefined !== this.getPage.records[this.index].price &&
        undefined !== this.getPage.records[this.index].quantity
      ) {
        this.getPage.records[this.index].totalPrice =
          this.getPage.records[this.index].quantity *
          this.getPage.records[this.index].price
      }
    },

    _inputBack(data) {
      console.log(data)
      if (undefined !== data) {
        if (this.getPage.records.length > 0) {
          const j = this.getPage.records.length
          for (let i = j; i < data.length + j; i++) {
            console.log(i)
            this.getPage.records.push(data[i - j])
            if (data[i - j].lastTime !== undefined) {
              this.getPage.records[i].lastTime = new Date(data[i - j].lastTime)
            }
            console.log(this.getPage.records)
            // this.getPage.records[i].lastTime = new Date(data[0].lastTime)
          }
        } else {
          for (let i = 0; i < data.length; i++) {
            // if (this.getPage.records[i].lastTime !== undefined) {
            //   const t = this.getPage.records[i].lastTime
            //   const d = t.valueOf(t)
            //   console.log('时间戳', d)
            //   this.getPage.records[i].lastTime = d
            //   this.getPage.records = []
            // }
            this.getPage.records.push(data[i])
            if (data[i].lastTime !== undefined) {
              this.getPage.records[i].lastTime = new Date(data[i].lastTime)
            }
            console.log(data[i].lastTime)
          }
        }
      }
    },
    _add() {
      const data = {
        name: '',
        spec: '',
        factoryNumber: '',
        quantity: '',
        type: ''
      }
      this.getPage.records.unshift(data)
    },
    _tableResultChange(msg, data) {
      switch (msg) {
        case 'page':
          // this.getPage = this.$store.state.FoodJudgeBasis.page
          break
        case 'selectIds':
          // this.selectIds = data
          break
        case 'iconClick':
          this._iconClick(data.name, data.rowData, data.rowIndex)
          break
      }
    },
    _btnClick(msg) {
      this.$nextTick(function() {
        switch (msg) {
          case '导入':
            this._import()
            break
          case '添加':
            this._add()
            break
          case '提交':
            this._submitToReview()
            break
          case 'search':
            this.searchOpen = !this.searchOpen
            break
        }
      })
    },
    _import() {
      const data = {
        importUrl: '/meter/v1/sample_quote/import',
        downloadUrl: '/meter/v1/excel/template/QuotationList',
        title: '导入'
      }
      this.$refs.importModal._open(data, '报价单导入')
    },
    // 省 市 区
    _cascaderResult(name, data, msg) {
      switch (name) {
        case 'cus':
          this._casChange(data, msg)
          break
        case 'tested':
          this._testedChange(data, msg)
          break
      }
    },
    _emptyProvince() {
      this.cityData = []
      this.testedCityData = []
      // this.formObj.tested.testedProvince = ''
      // this.formObj.tested.testedCity = ''
      // this.formObj.tested.testedCounty = ''
      // this.formObj.testedTemp.testedProvince = ''
      // this.formObj.testedTemp.testedCity = ''
      // this.formObj.testedTemp.testedCounty = ''
    },
    _testedChange(data, msg) {
      // 省、市、区
      if (msg === 'clear') {
        // this.formObj.tested.testedProvince = ''
        // this.formObj.tested.testedCity = ''
        // this.formObj.tested.testedCounty = ''
        this.formObj.testedTemp.testedProvince = ''
        this.formObj.testedTemp.testedCity = ''
        this.formObj.testedTemp.testedCounty = ''
        this.formObj.province = ''
        this.formObj.city = ''
        this.formObj.county = ''
        this.testedCityData = []
      } else {
        // this.formObj.tested.testedProvince = data.value[0]
        // this.formObj.tested.testedCity = data.value[1]
        // this.formObj.tested.testedCounty = data.value[2]
        this.formObj.province = data.value[0]
        this.formObj.city = data.value[1]
        this.formObj.county = data.value[2]
        this.testedCityData = [data.value[0], data.value[1], data.value[2]]
      }
    },

    _iconClick(res, data, index) {
      switch (res) {
        case '编辑':
          // this._editModal(true, data.id)
          break
        case '删除':
          this._deleted(data)
          console.log('点击了删除按钮')
          console.log(index)
          this.getPage.records.splice(index, 1)
          break
        case '操作日志':
          // this._record(data.id)
          break
      }
    },

    _deleted(data) {
      if (undefined !== data.id) {
        this._deleteById(data.id)
      }
    },
    _deleteById: async function(ids) {
      const result = await meterSampleQuote.deleteById(ids)
      if (result) {
        this.$Message.success('删除成功！')
      }
    },
    _selectAptitude(data) {
      console.log(data)
    },
    _handleRow(data) {
      this.currentRow = data.row
      this.currentIndex = data.rowIndex
    },
    channelInputLimit(e) {
      const key = e.key
      // 不允许输入'e'和'.'
      if (key === 'e' || key === '.') {
        e.returnValue = false
        return false
      }
      return true
    },
    /** *modal-footer */
    _footerResult(name) {
      switch (name) {
        case '取消':
          this._cancel()
          break
        case '保存':
          this._ok()
          break
      }
    },
    _hideLoading() {
      this.$refs.footerModal._hideLoading()
    },
    _resultChange(msg) {
      this.showModal = false
      this.$Message.success(msg)
      this.$emit('on-result-change')
      this._hideLoading()
    },
    _ok() {
      this.$refs.formObj.validate(valid => {
        if (valid) {
          const data = this.$serialize('edit-form')
          Object.assign(this.formObj, data)
          if (this.$string(this.id).isEmpty()) {
            // 添加
            const saveData = this.formObj
            saveData.sampleList = this.getPage.records
            console.log('saveData-------', saveData)
            this._save(saveData)
          } else {
            // 编辑
            // this._edit({ id: this.formObj.id, obj: data })
            const saveData = this.formObj
            saveData.sampleList = this.getPage.records
            this._edit(saveData)
          }
        } else {
          this.$Message.error('表单验证失败!')
          this._hideLoading()
        }
      })
    },
    _wayResult(msg, data) {
      switch (msg) {
        case 'select':
          this.formObj.clearingWay = data
          break
        case 'query':
          this.formObj.clearingWay = data
          this._wayQuery(data)
          break
      }
    },
    _wayQuery(query) {
      if (query === '') {
        this.clearingWayList = this.clearingWayListTemp
      } else {
        this.clearingWayList = this.clearingWayListTemp.filter(
          item => item.indexOf(query) > -1
        )
      }
    },
    _cancel() {
      this.showModal = false
    },
    _open(formObj) {
      this.formObj.client = ''
      this.formObj.clientId = undefined
      this.showModal = true
      this._getList()
      this.$refs.formObj.resetFields()
      this._emptyProvince()
      this._hideLoading()
      if (this.$string(formObj).isEmpty()) {
        this.getPage.records = []
        this.id = ''
        this.modalTitle = '报价单新增'
      } else {
        this.id = formObj.id
        this.formObj = formObj
        this.modalTitle = '报价单编辑'
        this._showTime(formObj)
        this._showAddress(formObj)
      }
    },

    _showAddress(formObj) {
      this.testedCityData = []
      if (
        formObj.province !== undefined &&
        formObj.city !== undefined &&
        formObj.county !== undefined
      ) {
        this.testedCityData.push(formObj.province)
        this.testedCityData.push(formObj.city)
        this.testedCityData.push(formObj.county)
      }
    },

    _openEdit(formObj) {
      this._getList()
      this.getPage.records = []
      this.showModal = true
      this.$refs.formObj.resetFields()
      this._hideLoading()
      this.id = ''
      this.modalTitle = '报价单编辑'
      this.id = formObj.id
      this.formObj = formObj
      this.formObj.client = formObj.client
      this._showAddress(formObj)
      this._showTime(formObj)
      this.getPage.records = formObj.sampleList
      console.log(formObj)
      for (let i = 0; i < formObj.sampleList.length; i++) {
        if (formObj.sampleList[i].lastTime !== undefined) {
          this.getPage.records[i].lastTime = new Date(
            formObj.sampleList[i].lastTime
          )
        }
      }
    },
    _getList: async function() {
      const result = await meterEntrust.pageList()
      const list = []
      if (result) {
        for (let i = 0; i < result.length; i++) {
          list.push(result[i].cname)
        }
        console.log('委托单位名单', list)
        this.customerData = list
      }
    },
    _getQueryList: async function(data) {
      const result = await meterEntrust.pageQueryList(data)
      console.log(result)
      if (result) {
        this.formObj.client = data
        this.formObj.person = result[0].contact
        this.formObj.tel = result[0].mobile
        this.formObj.fax = result[0].fax
        this.testedCityData = [
          result[0].province,
          result[0].city,
          result[0].area
        ]
        this.formObj.province = result[0].province
        this.formObj.city = result[0].city
        this.formObj.county = result[0].area
      }
    },
    _getAptitudeList: async function() {
      const result = await lmsBaseDict.getItem('subcontractorAptitude')
      if (result) {
        this.aptitudeData = result
      }
    },
    _showTime(formObj) {
      if (this.formObj.odate === undefined) {
        this.formObj.odate = ''
      } else {
        this.formObj.odate = new Date(formObj.odate)
      }
    },
    _save: async function(data) {
      const result = await meterContract.addQuote(data)
      console.log(result)
      if (result) {
        this._resultChange('添加成功!')
      }
    },
    _edit: async function(data) {
      const result = await meterContract.editDTO(data)
      console.log('修改后')
      console.log(result)
      if (result) {
        this._resultChange('编辑成功!')
      }
    }
  }
}
</script>
